package com.diagbot.facade;

import com.diagbot.dto.QcCasesDTO;
import com.diagbot.exception.CommonErrorCode;
import com.diagbot.exception.CommonException;
import com.diagbot.service.impl.QcCasesServiceImpl;
import com.diagbot.util.DateUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.SysUserUtils;
import com.diagbot.vo.QcCasesQueryVO;
import com.diagbot.vo.QcCasesSaveVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

/**
 * @Description:
 * @author: gaodm
 * @time: 2020/4/12 14:07
 */
@Component
public class QcCasesFacade extends QcCasesServiceImpl {

    @Autowired
    private QcCasesHospitalFacade qcCasesHospitalFacade;

    public List<QcCasesDTO> getQcCasesFac() {
        QcCasesQueryVO queryVO = new QcCasesQueryVO();
        queryVO.setHospitalId(Long.valueOf(SysUserUtils.getCurrentHospitalID()));
        return this.getQcCases(queryVO);
    }

    public Boolean saveQcCases(List<QcCasesSaveVO> qcCasesSaveVOList) {
        if (ListUtil.isNotEmpty(qcCasesSaveVOList)) {
            Date now = DateUtil.now();
            for (QcCasesSaveVO qcCasesSaveVO : qcCasesSaveVOList) {
                qcCasesSaveVO.setHospitalId(Long.valueOf(SysUserUtils.getCurrentHospitalID()));
                qcCasesSaveVO.setModifier(SysUserUtils.getCurrentPrincipleID());
                qcCasesSaveVO.setGmtModified(now);
            }
        } else {
            throw new CommonException(CommonErrorCode.PARAM_IS_NULL);
        }
        qcCasesHospitalFacade.updateBatch(qcCasesSaveVOList);
        return true;

    }
}
